Index: source/renderer/scripting/JSInterface_Renderer.h
===================================================================
--- source/renderer/scripting/JSInterface_Renderer.h	(Revision 14461)
+++ source/renderer/scripting/JSInterface_Renderer.h	(Arbeitskopie)
@@ -19,16 +19,16 @@
 #ifndef INCLUDED_JSINTERFACE_RENDERER
 #define INCLUDED_JSINTERFACE_RENDERER
 
-class ScriptInterface;
+#include "scriptinterface/ScriptInterface.h"
 
 #define DECLARE_BOOLEAN_SCRIPT_SETTING(NAME) \
-	bool Get##NAME##Enabled(void* cbdata); \
-	void Set##NAME##Enabled(void* cbdata, bool Enabled);
+	bool Get##NAME##Enabled(ScriptInterface::CxPrivate* pCxPrivate); \
+	void Set##NAME##Enabled(ScriptInterface::CxPrivate* pCxPrivate, bool Enabled);
 
 namespace JSI_Renderer
 {
-	std::string GetRenderPath(void* cbdata);
-	void SetRenderPath(void* cbdata, std::string name);
+	std::string GetRenderPath(ScriptInterface::CxPrivate* pCxPrivate);
+	void SetRenderPath(ScriptInterface::CxPrivate* pCxPrivate, std::string name);
 
 	DECLARE_BOOLEAN_SCRIPT_SETTING(Shadows);
 	DECLARE_BOOLEAN_SCRIPT_SETTING(ShadowPCF);
Index: source/renderer/scripting/JSInterface_Renderer.cpp
===================================================================
--- source/renderer/scripting/JSInterface_Renderer.cpp	(Revision 14461)
+++ source/renderer/scripting/JSInterface_Renderer.cpp	(Arbeitskopie)
@@ -21,12 +21,12 @@
 #include "renderer/Renderer.h"
 
 #define IMPLEMENT_BOOLEAN_SCRIPT_SETTING(NAME, SCRIPTNAME) \
-bool JSI_Renderer::Get##SCRIPTNAME##Enabled(void* UNUSED(cbdata)) \
+bool JSI_Renderer::Get##SCRIPTNAME##Enabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate)) \
 { \
 	return g_Renderer.GetOptionBool(CRenderer::OPT_##NAME); \
 } \
 \
-void JSI_Renderer::Set##SCRIPTNAME##Enabled(void* UNUSED(cbdata), bool Enabled) \
+void JSI_Renderer::Set##SCRIPTNAME##Enabled(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool Enabled) \
 { \
 	g_Renderer.SetOptionBool(CRenderer::OPT_##NAME, Enabled); \
 }
@@ -47,12 +47,12 @@
 
 #undef IMPLEMENT_BOOLEAN_SCRIPT_SETTING
 
-std::string JSI_Renderer::GetRenderPath(void* UNUSED(cbdata))
+std::string JSI_Renderer::GetRenderPath(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	return CRenderer::GetRenderPathName(g_Renderer.GetRenderPath());
 }
 
-void JSI_Renderer::SetRenderPath(void* UNUSED(cbdata), std::string name)
+void JSI_Renderer::SetRenderPath(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::string name)
 {
 	g_Renderer.SetRenderPath(CRenderer::GetRenderPathByName(name));
 }
Index: source/lobby/scripting/JSInterface_Lobby.h
===================================================================
--- source/lobby/scripting/JSInterface_Lobby.h	(Revision 14461)
+++ source/lobby/scripting/JSInterface_Lobby.h	(Arbeitskopie)
@@ -18,48 +18,47 @@
 #ifndef INCLUDED_JSI_LOBBY
 #define INCLUDED_JSI_LOBBY
 
+#include "scriptinterface/ScriptInterface.h"
 #include "scriptinterface/ScriptVal.h"
 #include "lib/config2.h" // for CONFIG2_LOBBY
 
-class ScriptInterface;
-
 namespace JSI_Lobby
 {
-	bool HasXmppClient(void* cbdata);
+	bool HasXmppClient(ScriptInterface::CxPrivate* pCxPrivate);
 	
 #if CONFIG2_LOBBY 
-	void StartXmppClient(void* cbdata, std::wstring username, std::wstring password, std::wstring room, std::wstring nick);
-	void StartRegisterXmppClient(void* cbdata, std::wstring username, std::wstring password);
-	void StopXmppClient(void* cbdata);
-	void ConnectXmppClient(void* cbdata);
-	void DisconnectXmppClient(void* cbdata);
-	void RecvXmppClient(void* cbdata);
-	void SendGetGameList(void* cbdata);
-	void SendGetBoardList(void* cbdata);
-	void SendGameReport(void* cbdata, CScriptVal data);
-	void SendRegisterGame(void* cbdata, CScriptVal data);
-	void SendUnregisterGame(void* cbdata);
-	void SendChangeStateGame(void* cbdata, std::wstring nbp, std::wstring players);
-	CScriptVal GetPlayerList(void* cbdata);
-	CScriptVal GetGameList(void* cbdata);
-	CScriptVal GetBoardList(void* cbdata);
-	CScriptVal LobbyGuiPollMessage(void* cbdata);
-	void LobbySendMessage(void* cbdata, std::wstring message);
-	void LobbySetPlayerPresence(void* cbdata, std::wstring presence);
-	void LobbySetNick(void* cbdata, std::wstring nick);
-	std::wstring LobbyGetNick(void* cbdata);
-	void LobbyKick(void* cbdata, std::wstring nick, std::wstring reason);
-	void LobbyBan(void* cbdata, std::wstring nick, std::wstring reason);
-	std::wstring LobbyGetPlayerPresence(void* cbdata, std::wstring nickname);
+	void StartXmppClient(ScriptInterface::CxPrivate* pCxPrivate, std::wstring username, std::wstring password, std::wstring room, std::wstring nick);
+	void StartRegisterXmppClient(ScriptInterface::CxPrivate* pCxPrivate, std::wstring username, std::wstring password);
+	void StopXmppClient(ScriptInterface::CxPrivate* pCxPrivate);
+	void ConnectXmppClient(ScriptInterface::CxPrivate* pCxPrivate);
+	void DisconnectXmppClient(ScriptInterface::CxPrivate* pCxPrivate);
+	void RecvXmppClient(ScriptInterface::CxPrivate* pCxPrivate);
+	void SendGetGameList(ScriptInterface::CxPrivate* pCxPrivate);
+	void SendGetBoardList(ScriptInterface::CxPrivate* pCxPrivate);
+	void SendGameReport(ScriptInterface::CxPrivate* pCxPrivate, CScriptVal data);
+	void SendRegisterGame(ScriptInterface::CxPrivate* pCxPrivate, CScriptVal data);
+	void SendUnregisterGame(ScriptInterface::CxPrivate* pCxPrivate);
+	void SendChangeStateGame(ScriptInterface::CxPrivate* pCxPrivate, std::wstring nbp, std::wstring players);
+	CScriptVal GetPlayerList(ScriptInterface::CxPrivate* pCxPrivate);
+	CScriptVal GetGameList(ScriptInterface::CxPrivate* pCxPrivate);
+	CScriptVal GetBoardList(ScriptInterface::CxPrivate* pCxPrivate);
+	CScriptVal LobbyGuiPollMessage(ScriptInterface::CxPrivate* pCxPrivate);
+	void LobbySendMessage(ScriptInterface::CxPrivate* pCxPrivate, std::wstring message);
+	void LobbySetPlayerPresence(ScriptInterface::CxPrivate* pCxPrivate, std::wstring presence);
+	void LobbySetNick(ScriptInterface::CxPrivate* pCxPrivate, std::wstring nick);
+	std::wstring LobbyGetNick(ScriptInterface::CxPrivate* pCxPrivate);
+	void LobbyKick(ScriptInterface::CxPrivate* pCxPrivate, std::wstring nick, std::wstring reason);
+	void LobbyBan(ScriptInterface::CxPrivate* pCxPrivate, std::wstring nick, std::wstring reason);
+	std::wstring LobbyGetPlayerPresence(ScriptInterface::CxPrivate* pCxPrivate, std::wstring nickname);
 
 	// Non-public secure PBKDF2 hash function with salting and 1,337 iterations
 	std::string EncryptPassword(const std::string& password, const std::string& username);
 
 	// Public hash interface.
-	std::wstring EncryptPassword(void* cbdata, std::wstring pass, std::wstring user);
+	std::wstring EncryptPassword(ScriptInterface::CxPrivate* pCxPrivate, std::wstring pass, std::wstring user);
 	
-	bool IsRankedGame(void* cbdata);
-	void SetRankedGame(void* cbdata, bool isRanked);
+	bool IsRankedGame(ScriptInterface::CxPrivate* pCxPrivate);
+	void SetRankedGame(ScriptInterface::CxPrivate* pCxPrivate, bool isRanked);
 #endif // CONFIG2_LOBBY 
 }
 
Index: source/lobby/scripting/JSInterface_Lobby.cpp
===================================================================
--- source/lobby/scripting/JSInterface_Lobby.cpp	(Revision 14461)
+++ source/lobby/scripting/JSInterface_Lobby.cpp	(Arbeitskopie)
@@ -27,14 +27,14 @@
 
 #include "scriptinterface/ScriptInterface.h"
 
-bool JSI_Lobby::HasXmppClient(void* UNUSED(cbdata))
+bool JSI_Lobby::HasXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	return (g_XmppClient ? true : false);
 }
 
 #if CONFIG2_LOBBY
 
-void JSI_Lobby::StartXmppClient(void* UNUSED(cbdata), std::wstring username, std::wstring password, std::wstring room, std::wstring nick)
+void JSI_Lobby::StartXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring username, std::wstring password, std::wstring room, std::wstring nick)
 {
 	ENSURE(!g_XmppClient);
 
@@ -43,7 +43,7 @@
 	g_rankedGame = true;
 }
 
-void JSI_Lobby::StartRegisterXmppClient(void* UNUSED(cbdata), std::wstring username, std::wstring password)
+void JSI_Lobby::StartRegisterXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring username, std::wstring password)
 {
 	ENSURE(!g_XmppClient);
 
@@ -51,123 +51,117 @@
 		"", "", true);
 }
 
-void JSI_Lobby::StopXmppClient(void* UNUSED(cbdata))
+void JSI_Lobby::StopXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	ENSURE(g_XmppClient);
 	SAFE_DELETE(g_XmppClient);
 	g_rankedGame = false;
 }
 
-void JSI_Lobby::ConnectXmppClient(void* UNUSED(cbdata))
+void JSI_Lobby::ConnectXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	ENSURE(g_XmppClient);
 	g_XmppClient->connect();
 }
 
-void JSI_Lobby::DisconnectXmppClient(void* UNUSED(cbdata))
+void JSI_Lobby::DisconnectXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	ENSURE(g_XmppClient);
 	g_XmppClient->disconnect();
 }
 
-void JSI_Lobby::RecvXmppClient(void* UNUSED(cbdata))
+void JSI_Lobby::RecvXmppClient(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!g_XmppClient)
 		return;
 	g_XmppClient->recv();
 }
 
-void JSI_Lobby::SendGetGameList(void* UNUSED(cbdata))
+void JSI_Lobby::SendGetGameList(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!g_XmppClient)
 		return;
 	g_XmppClient->SendIqGetGameList();
 }
 
-void JSI_Lobby::SendGetBoardList(void* UNUSED(cbdata))
+void JSI_Lobby::SendGetBoardList(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!g_XmppClient)
 		return;
 	g_XmppClient->SendIqGetBoardList();
 }
 
-void JSI_Lobby::SendGameReport(void* cbdata, CScriptVal data)
+void JSI_Lobby::SendGameReport(ScriptInterface::CxPrivate* pCxPrivate, CScriptVal data)
 {
 	if (!g_XmppClient)
 		return;
 
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	g_XmppClient->SendIqGameReport(guiManager->GetScriptInterface(), data);
+	g_XmppClient->SendIqGameReport(*(pCxPrivate->pScriptInterface), data);
 }
 
-void JSI_Lobby::SendRegisterGame(void* cbdata, CScriptVal data)
+void JSI_Lobby::SendRegisterGame(ScriptInterface::CxPrivate* pCxPrivate, CScriptVal data)
 {
 	if (!g_XmppClient)
 		return;
-	
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	g_XmppClient->SendIqRegisterGame(guiManager->GetScriptInterface(), data);
+
+	g_XmppClient->SendIqRegisterGame(*(pCxPrivate->pScriptInterface), data);
 }
 
-void JSI_Lobby::SendUnregisterGame(void* UNUSED(cbdata))
+void JSI_Lobby::SendUnregisterGame(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!g_XmppClient)
 		return;
 	g_XmppClient->SendIqUnregisterGame();
 }
 
-void JSI_Lobby::SendChangeStateGame(void* UNUSED(cbdata), std::wstring nbp, std::wstring players)
+void JSI_Lobby::SendChangeStateGame(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring nbp, std::wstring players)
 {
 	if (!g_XmppClient)
 		return;
 	g_XmppClient->SendIqChangeStateGame(utf8_from_wstring(nbp), utf8_from_wstring(players));
 }
 
-CScriptVal JSI_Lobby::GetPlayerList(void* cbdata)
+CScriptVal JSI_Lobby::GetPlayerList(ScriptInterface::CxPrivate* pCxPrivate)
 {
 	if (!g_XmppClient)
 		return CScriptVal();
 		
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	CScriptValRooted playerList = g_XmppClient->GUIGetPlayerList(guiManager->GetScriptInterface());
+	CScriptValRooted playerList = g_XmppClient->GUIGetPlayerList(*(pCxPrivate->pScriptInterface));
 
 	return playerList.get();
 }
 
-CScriptVal JSI_Lobby::GetGameList(void* cbdata)
+CScriptVal JSI_Lobby::GetGameList(ScriptInterface::CxPrivate* pCxPrivate)
 {
 	if (!g_XmppClient)
 		return CScriptVal();
 
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	CScriptValRooted gameList = g_XmppClient->GUIGetGameList(guiManager->GetScriptInterface());
+	CScriptValRooted gameList = g_XmppClient->GUIGetGameList(*(pCxPrivate->pScriptInterface));
 
 	return gameList.get();
 }
 
-CScriptVal JSI_Lobby::GetBoardList(void* cbdata)
+CScriptVal JSI_Lobby::GetBoardList(ScriptInterface::CxPrivate* pCxPrivate)
 {
 	if (!g_XmppClient)
 		return CScriptVal();
 
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	CScriptValRooted boardList = g_XmppClient->GUIGetBoardList(guiManager->GetScriptInterface());
+	CScriptValRooted boardList = g_XmppClient->GUIGetBoardList(*(pCxPrivate->pScriptInterface));
 
 	return boardList.get();
 }
 
-CScriptVal JSI_Lobby::LobbyGuiPollMessage(void* cbdata)
+CScriptVal JSI_Lobby::LobbyGuiPollMessage(ScriptInterface::CxPrivate* pCxPrivate)
 {
 	if (!g_XmppClient)
 		return CScriptVal();
-		
-	CGUIManager* guiManager = static_cast<CGUIManager*> (cbdata);
-	CScriptValRooted poll = g_XmppClient->GuiPollMessage(guiManager->GetScriptInterface());
+	
+	CScriptValRooted poll = g_XmppClient->GuiPollMessage(*(pCxPrivate->pScriptInterface));
 
 	return poll.get();
 }
 
-void JSI_Lobby::LobbySendMessage(void* UNUSED(cbdata), std::wstring message)
+void JSI_Lobby::LobbySendMessage(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring message)
 {
 	if (!g_XmppClient)
 		return;
@@ -175,7 +169,7 @@
 	g_XmppClient->SendMUCMessage(utf8_from_wstring(message));
 }
 
-void JSI_Lobby::LobbySetPlayerPresence(void* UNUSED(cbdata), std::wstring presence)
+void JSI_Lobby::LobbySetPlayerPresence(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring presence)
 {
 	if (!g_XmppClient)
 		return;
@@ -183,7 +177,7 @@
 	g_XmppClient->SetPresence(utf8_from_wstring(presence));
 }
 
-void JSI_Lobby::LobbySetNick(void* UNUSED(cbdata), std::wstring nick)
+void JSI_Lobby::LobbySetNick(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring nick)
 {
 	if (!g_XmppClient)
 		return;
@@ -191,7 +185,7 @@
 	g_XmppClient->SetNick(utf8_from_wstring(nick));
 }
 
-std::wstring JSI_Lobby::LobbyGetNick(void* UNUSED(cbdata))
+std::wstring JSI_Lobby::LobbyGetNick(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	if (!g_XmppClient)
 		return L"";
@@ -201,7 +195,7 @@
 	return wstring_from_utf8(nick);
 }
 
-void JSI_Lobby::LobbyKick(void* UNUSED(cbdata), std::wstring nick, std::wstring reason)
+void JSI_Lobby::LobbyKick(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring nick, std::wstring reason)
 {
 	if (!g_XmppClient)
 		return;
@@ -209,7 +203,7 @@
 	g_XmppClient->kick(utf8_from_wstring(nick), utf8_from_wstring(reason));
 }
 
-void JSI_Lobby::LobbyBan(void* UNUSED(cbdata), std::wstring nick, std::wstring reason)
+void JSI_Lobby::LobbyBan(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring nick, std::wstring reason)
 {
 	if (!g_XmppClient)
 		return;
@@ -217,7 +211,7 @@
 	g_XmppClient->ban(utf8_from_wstring(nick), utf8_from_wstring(reason));
 }
 
-std::wstring JSI_Lobby::LobbyGetPlayerPresence(void* UNUSED(cbdata), std::wstring nickname)
+std::wstring JSI_Lobby::LobbyGetPlayerPresence(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring nickname)
 {
 	if (!g_XmppClient)
 		return L"";
@@ -258,17 +252,17 @@
 	return std::string(hex, sizeof(hex));
 }
 
-std::wstring JSI_Lobby::EncryptPassword(void* UNUSED(cbdata), std::wstring pass, std::wstring user)
+std::wstring JSI_Lobby::EncryptPassword(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::wstring pass, std::wstring user)
 {
 	return wstring_from_utf8(JSI_Lobby::EncryptPassword(utf8_from_wstring(pass), utf8_from_wstring(user)));
 }
 
-bool JSI_Lobby::IsRankedGame(void* UNUSED(cbdata))
+bool JSI_Lobby::IsRankedGame(ScriptInterface::CxPrivate* UNUSED(pCxPrivate))
 {
 	return g_rankedGame;
 }
 
-void JSI_Lobby::SetRankedGame(void* UNUSED(cbdata), bool isRanked)
+void JSI_Lobby::SetRankedGame(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool isRanked)
 {
 	g_rankedGame = isRanked;
 }
Index: source/ps/GameSetup/GameSetup.cpp
===================================================================
--- source/ps/GameSetup/GameSetup.cpp	(Revision 14461)
+++ source/ps/GameSetup/GameSetup.cpp	(Arbeitskopie)
@@ -44,8 +44,6 @@
 #include "graphics/TerrainTextureManager.h"
 #include "gui/GUI.h"
 #include "gui/GUIManager.h"
-#include "gui/scripting/JSInterface_IGUIObject.h"
-#include "gui/scripting/JSInterface_GUITypes.h"
 #include "gui/scripting/ScriptFunctions.h"
 #include "maths/MathUtil.h"
 #include "network/NetServer.h"
@@ -81,8 +79,6 @@
 #include "renderer/Renderer.h"
 #include "renderer/VertexBufferManager.h"
 #include "renderer/ModelRenderer.h"
-#include "scripting/ScriptingHost.h"
-#include "scripting/ScriptGlue.h"
 #include "scriptinterface/DebuggingServer.h"
 #include "scriptinterface/ScriptInterface.h"
 #include "scriptinterface/ScriptStats.h"
@@ -115,6 +111,8 @@
 bool g_DoRenderLogger = true;
 bool g_DoRenderCursor = true;
 
+shared_ptr<ScriptRuntime> g_ScriptRuntime;
+
 static const int SANE_TEX_QUALITY_DEFAULT = 5;	// keep in sync with code
 
 static void SetTextureQuality(int quality)
@@ -182,9 +180,9 @@
 // display progress / description in loading screen
 void GUI_DisplayLoadProgress(int percent, const wchar_t* pending_task)
 {
-	g_ScriptingHost.GetScriptInterface().SetGlobal("g_Progress", percent, true);
-	g_ScriptingHost.GetScriptInterface().SetGlobal("g_LoadDescription", pending_task, true);
-	g_GUI->SendEventToAll("progress");
+	g_GUI->GetActiveGUI()->GetScriptInterface()->SetGlobal("g_Progress", percent, true);
+	g_GUI->GetActiveGUI()->GetScriptInterface()->SetGlobal("g_LoadDescription", pending_task, true);
+	g_GUI->GetActiveGUI()->SendEventToAll("progress");
 }
 
 
@@ -320,28 +318,6 @@
 }
 
 
-static void RegisterJavascriptInterfaces()
-{
-	// GUI
-	CGUI::ScriptingInit();
-
-	GuiScriptingInit(g_ScriptingHost.GetScriptInterface());
-	JSI_Sound::RegisterScriptFunctions(g_ScriptingHost.GetScriptInterface());
-}
-
-
-static void InitScripting()
-{
-	TIMER(L"InitScripting");
-
-	// Create the scripting host.  This needs to be done before the GUI is created.
-	// [7ms]
-	new ScriptingHost;
-	
-	RegisterJavascriptInterfaces();
-}
-
-
 static size_t OperatingSystemFootprint()
 {
 #if OS_WIN
@@ -499,7 +475,7 @@
 }
 
 
-static void InitPs(bool setup_gui, const CStrW& gui_page, CScriptVal initData)
+static void InitPs(bool setup_gui, const CStrW& gui_page, ScriptInterface* srcScriptInterface, CScriptVal initData)
 {
 	{
 		// console
@@ -530,12 +506,12 @@
 	{
 		// We do actually need *some* kind of GUI loaded, so use the
 		// (currently empty) Atlas one
-		g_GUI->SwitchPage(L"page_atlas.xml", initData);
+		g_GUI->SwitchPage(L"page_atlas.xml", srcScriptInterface, initData);
 		return;
 	}
 
 	// GUI uses VFS, so this must come after VFS init.
-	g_GUI->SwitchPage(gui_page, initData);
+	g_GUI->SwitchPage(gui_page, srcScriptInterface, initData);
 }
 
 
@@ -687,7 +663,7 @@
 
 	SAFE_DELETE(g_XmppClient);
 
-	ShutdownPs(); // Must delete g_GUI before g_ScriptingHost
+	ShutdownPs();
 
 	in_reset_handlers();
 
@@ -718,10 +694,9 @@
 	g_UserReporter.Deinitialize();
 	TIMER_END(L"shutdown UserReporter");
 
-	TIMER_BEGIN(L"shutdown ScriptingHost");
-	delete &g_ScriptingHost;
+	TIMER_BEGIN(L"shutdown DebuggingServer (if active)");
 	delete g_DebuggingServer;
-	TIMER_END(L"shutdown ScriptingHost");
+	TIMER_END(L"shutdown DebuggingServer (if active)");
 
 	TIMER_BEGIN(L"shutdown ConfigDB");
 	delete &g_ConfigDB;
@@ -875,13 +850,16 @@
 	// This must come after VFS init, which sets the current directory
 	// (required for finding our output log files).
 	g_Logger = new CLogger;
+	
+	// Workaround until Simulation and AI use their own threads and also their own runtimes
+	g_ScriptRuntime = ScriptInterface::CreateRuntime(128 * 1024 * 1024);
 
 	// Special command-line mode to dump the entity schemas instead of running the game.
 	// (This must be done after loading VFS etc, but should be done before wasting time
 	// on anything else.)
 	if (args.Has("dumpSchema"))
 	{
-		CSimulation2 sim(NULL, NULL);
+		CSimulation2 sim(NULL, g_ScriptRuntime, NULL);
 		sim.LoadDefaultScripts();
 		std::ofstream f("entity.rng", std::ios_base::out | std::ios_base::trunc);
 		f << sim.GenerateSchema();
@@ -920,8 +898,6 @@
 	if (g_JSDebuggerEnabled)
 		g_DebuggingServer = new CDebuggingServer();
 
-	InitScripting();	// before GUI
-
 	// Optionally start profiler HTTP output automatically
 	// (By default it's only enabled by a hotkey, for security/performance)
 	bool profilerHTTPEnable = false;
@@ -977,7 +953,7 @@
 	if(g_DisableAudio)
 		ISoundManager::SetEnabled(false);
 
-	g_GUI = new CGUIManager(g_ScriptingHost.GetScriptInterface());
+	g_GUI = new CGUIManager();
 
 	// (must come after SetVideoMode, since it calls ogl_Init)
 	if (ogl_HaveExtensions(0, "GL_ARB_vertex_program", "GL_ARB_fragment_program", NULL) != 0 // ARB
@@ -1036,11 +1012,11 @@
 			CScriptValRooted data;
 			if (g_GUI)
 			{
-				ScriptInterface& scriptInterface = g_GUI->GetScriptInterface();
-				scriptInterface.Eval("({})", data);
-				scriptInterface.SetProperty(data.get(), "isStartup", true);
+				shared_ptr<ScriptInterface> scriptInterface = g_GUI->GetScriptInterface();
+				scriptInterface->Eval("({})", data);
+				scriptInterface->SetProperty(data.get(), "isStartup", true);
 			}
-			InitPs(setup_gui, L"page_pregame.xml", data.get());
+			InitPs(setup_gui, L"page_pregame.xml", g_GUI->GetScriptInterface().get(), data.get());
 		}
 	}
 	catch (PSERROR_Game_World_MapLoadFailed& e)
@@ -1048,7 +1024,7 @@
 		// Map Loading failed
 
 		// Start the engine so we have a GUI
-		InitPs(true, L"page_pregame.xml", JSVAL_VOID);
+		InitPs(true, L"page_pregame.xml", NULL, JSVAL_VOID);
 
 		// Call script function to do the actual work
 		//	(delete game data, switch GUI page, show error, etc.)
@@ -1262,9 +1238,8 @@
 	scriptInterface.SetProperty(attrs.get(), "settings", settings);
 
 	CScriptVal mpInitData;
-	g_GUI->GetScriptInterface().Eval("({isNetworked:true, playerAssignments:{}})", mpInitData);
-	g_GUI->GetScriptInterface().SetProperty(mpInitData.get(), "attribs",
-			CScriptVal(g_GUI->GetScriptInterface().CloneValueFromOtherContext(scriptInterface, attrs.get())));
+	scriptInterface.Eval("({isNetworked:true, playerAssignments:{}})", mpInitData);
+	scriptInterface.SetProperty(mpInitData.get(), "attribs", attrs);
 
 	// Get optional playername
 	CStrW userName = L"anonymous";
@@ -1275,7 +1250,7 @@
 
 	if (args.Has("autostart-host"))
 	{
-		InitPs(true, L"page_loading.xml", mpInitData.get());
+		InitPs(true, L"page_loading.xml", &scriptInterface, mpInitData.get());
 
 		size_t maxPlayers = 2;
 		if (args.Has("autostart-players"))
@@ -1296,7 +1271,7 @@
 	}
 	else if (args.Has("autostart-client"))
 	{
-		InitPs(true, L"page_loading.xml", mpInitData.get());
+		InitPs(true, L"page_loading.xml", &scriptInterface, mpInitData.get());
 
 		g_NetClient = new CNetClient(g_Game);
 		g_NetClient->SetUserName(userName);
@@ -1320,7 +1295,7 @@
 		PSRETURN ret = g_Game->ReallyStartGame();
 		ENSURE(ret == PSRETURN_OK);
 
-		InitPs(true, L"page_session.xml", JSVAL_VOID);
+		InitPs(true, L"page_session.xml", NULL, JSVAL_VOID);
 	}
 
 	return true;
@@ -1335,14 +1310,7 @@
 	// So all GUI pages that load games should include this script
 	if (g_GUI && g_GUI->HasPages())
 	{
-		JSContext* cx = g_ScriptingHost.getContext();
-		jsval fval, rval;
-		JSBool ok = JS_GetProperty(cx, g_GUI->GetScriptObject(), "cancelOnError", &fval);
-		ENSURE(ok);
-
-		jsval msgval = ScriptInterface::ToJSVal(cx, message);
-
-		if (ok && !JSVAL_IS_VOID(fval))
-			JS_CallFunctionValue(cx, g_GUI->GetScriptObject(), fval, 1, &msgval, &rval);
+		if (g_GUI->GetActiveGUI()->GetScriptInterface()->HasProperty(g_GUI->GetActiveGUI()->GetGlobalObject(), "cancelOnError" ))
+			g_GUI->GetActiveGUI()->GetScriptInterface()->CallFunctionVoid(g_GUI->GetActiveGUI()->GetGlobalObject(), "cancelOnError", message);
 	}
 }
Index: source/ps/GameSetup/HWDetect.cpp
===================================================================
--- source/ps/GameSetup/HWDetect.cpp	(Revision 14461)
+++ source/ps/GameSetup/HWDetect.cpp	(Arbeitskopie)
@@ -17,7 +17,6 @@
 
 #include "precompiled.h"
 
-#include "scripting/ScriptingHost.h"
 #include "scriptinterface/ScriptInterface.h"
 
 #include "lib/ogl.h"
@@ -123,30 +122,30 @@
 	return !(ns == CFG_LAST || ns == CFG_DEFAULT);
 }
 
-void SetDisableAudio(void* UNUSED(cbdata), bool disabled)
+void SetDisableAudio(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	g_DisableAudio = disabled;
 }
 
-void SetDisableS3TC(void* UNUSED(cbdata), bool disabled)
+void SetDisableS3TC(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("nos3tc"))
 		ogl_tex_override(OGL_TEX_S3TC, disabled ? OGL_TEX_DISABLE : OGL_TEX_ENABLE);
 }
 
-void SetDisableShadows(void* UNUSED(cbdata), bool disabled)
+void SetDisableShadows(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("shadows"))
 		g_Shadows = !disabled;
 }
 
-void SetDisableShadowPCF(void* UNUSED(cbdata), bool disabled)
+void SetDisableShadowPCF(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("shadowpcf"))
 		g_ShadowPCF = !disabled;
 }
 
-void SetDisableAllWater(void* UNUSED(cbdata), bool disabled)
+void SetDisableAllWater(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("waternormals"))
 		g_WaterNormal = !disabled;
@@ -163,7 +162,7 @@
 	if (!IsOverridden("watershadows"))
 		g_WaterShadows = !disabled;
 }
-void SetDisableFancyWater(void* UNUSED(cbdata), bool disabled)
+void SetDisableFancyWater(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("waterrealdepth"))
 		g_WaterRealDepth = !disabled;
@@ -174,7 +173,7 @@
 	if (!IsOverridden("watershadows"))
 		g_WaterShadows = !disabled;
 }
-void SetDisableFBOWater(void* UNUSED(cbdata), bool disabled)
+void SetDisableFBOWater(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), bool disabled)
 {
 	if (!IsOverridden("waterfoam"))
 		g_WaterFoam = !disabled;
@@ -182,7 +181,7 @@
 		g_WaterCoastalWaves = !disabled;
 }
 
-void SetRenderPath(void* UNUSED(cbdata), std::string renderpath)
+void SetRenderPath(ScriptInterface::CxPrivate* UNUSED(pCxPrivate), std::string renderpath)
 {
 	g_RenderPath = renderpath;
 }
@@ -191,7 +190,7 @@
 {
 	TIMER(L"RunHardwareDetection");
 
-	ScriptInterface& scriptInterface = g_ScriptingHost.GetScriptInterface();
+	ScriptInterface scriptInterface("Engine", "HWDetect", g_ScriptRuntime);
 
 	scriptInterface.RegisterFunction<void, bool, &SetDisableAudio>("SetDisableAudio");
 	scriptInterface.RegisterFunction<void, bool, &SetDisableS3TC>("SetDisableS3TC");
Index: source/ps/SavedGame.cpp
===================================================================
--- source/ps/SavedGame.cpp	(Revision 14461)
+++ source/ps/SavedGame.cpp	(Arbeitskopie)
@@ -81,7 +81,10 @@
 	simulation.GetScriptInterface().SetProperty(metadata.get(), "initAttributes", simulation.GetInitAttributes());
 	if (gui)
 	{
-		CScriptVal guiMetadata = simulation.GetScriptInterface().CloneValueFromOtherContext(gui->GetScriptInterface(), gui->GetSavedGameData().get());
+		ScriptInterface* pPageScriptInterface = NULL;
+		CScriptVal guiMetadataPageCx = gui->GetSavedGameData(pPageScriptInterface);
+
+		CScriptVal guiMetadata = simulation.GetScriptInterface().CloneValueFromOtherContext(*pPageScriptInterface, guiMetadataPageCx.get());
 		simulation.GetScriptInterface().SetProperty(metadata.get(), "gui", guiMetadata);
 	}
 	simulation.GetScriptInterface().SetProperty(metadata.get(), "description", description);
Index: source/ps/Game.cpp
===================================================================
--- source/ps/Game.cpp	(Revision 14461)
+++ source/ps/Game.cpp	(Arbeitskopie)
@@ -24,6 +24,7 @@
 #include "graphics/ParticleManager.h"
 #include "graphics/UnitManager.h"
 #include "gui/GUIManager.h"
+#include "gui/CGUI.h"
 #include "lib/config2.h"
 #include "lib/timer.h"
 #include "network/NetClient.h"
@@ -41,7 +42,6 @@
 #include "ps/GameSetup/GameSetup.h"
 #include "renderer/Renderer.h"
 #include "renderer/TimeManager.h"
-#include "scripting/ScriptingHost.h"
 #include "scriptinterface/ScriptInterface.h"
 #include "simulation2/Simulation2.h"
 #include "simulation2/components/ICmpPlayer.h"
@@ -64,7 +64,7 @@
  **/
 CGame::CGame(bool disableGraphics):
 	m_World(new CWorld(this)),
-	m_Simulation2(new CSimulation2(&m_World->GetUnitManager(), m_World->GetTerrain())),
+	m_Simulation2(new CSimulation2(&m_World->GetUnitManager(), g_ScriptRuntime, m_World->GetTerrain())),
 	m_GameView(disableGraphics ? NULL : new CGameView(this)),
 	m_GameStarted(false),
 	m_Paused(false),
@@ -233,11 +233,8 @@
 	// Call the reallyStartGame GUI function, but only if it exists
 	if (g_GUI && g_GUI->HasPages())
 	{
-		jsval fval, rval;
-		JSBool ok = JS_GetProperty(g_ScriptingHost.getContext(), g_GUI->GetScriptObject(), "reallyStartGame", &fval);
-		ENSURE(ok);
-		if (ok && !JSVAL_IS_VOID(fval))
-			JS_CallFunctionValue(g_ScriptingHost.getContext(), g_GUI->GetScriptObject(), fval, 0, NULL, &rval);
+		if (g_GUI->GetActiveGUI()->GetScriptInterface()->HasProperty(g_GUI->GetActiveGUI()->GetGlobalObject(), "reallyStartGame"))
+			g_GUI->GetActiveGUI()->GetScriptInterface()->CallFunctionVoid(g_GUI->GetActiveGUI()->GetGlobalObject(), "reallyStartGame");
 	}
 
 	if (g_NetClient)
